% Weak Magneto-Thermal coupling in Matlab-Opera
% Tran Tuan Vu - L2EP - EC-Lille

%-------------------------------------------------------------------------%

function [Tcu, Tfer, ren, dI, dV2] = Simulation_FE


%-------------------------------------------------------------------------%
%         Launch the boulce Magneto-Thermal in full-load           %
%-------------------------------------------------------------------------%               

% Give the link of folder of installation
global vfdir; vfdir='C:/OPERA';

% Give the link for Opra 3D MODELLER
global PathOPERA3dMODELLER_MA; PathOPERA3dMODELLER_MA=[vfdir '/bin/modeller.exe'];
global PathOPERA3dMODELLER_TH; PathOPERA3dMODELLER_TH=[vfdir '/bin/modeller.exe'];

% Give the link for Opra 3D POST-PROCESSOR
global PathOPERA3dPOST_MA; PathOPERA3dPOST_MA=[vfdir '/bin/post.exe'];
global PathOPERA3dPOST_TH; PathOPERA3dPOST_TH=[vfdir '/bin/post.exe'];

fprintf('\nLancer la boulce MAGNETO-THERMIQUE \n')
fid=fopen('temporaire_thermique.txt','r');
    T_init = textscan(fid, '%f %f')
    Tcu_initiale = T_init{1}
fclose(fid);
    
Tcu_old=0;
Tcu=Tcu_initiale;
i=0;
t=0;

% Boucle of weak Magnto-Thermal couppling
while abs(Tcu-Tcu_old)>0.1
    tic
    i=i+1;
    Tcu_old=Tcu;
    fprintf('\nItration no%2.0f, \n',i)
 
    % Launch automatically the file command MAGNETIC_pre.comi 
    PathOPERA3dMAGNETIC_pre=[PathOPERA3dMODELLER_MA ' transfor_magnetic_pre.comi'];

    % Get a move on OPERA 3D MAGNETIC_pre
    dos (PathOPERA3dMAGNETIC_pre, '-echo');

    % Launch automatically the file command MAGNETIC_post.comi 
    PathOPERA3dMAGNETIC_post=[PathOPERA3dPOST_MA ' transfor_magnetic_post.comi'];

    % Get a move on OPERA 3D MAGNETIC_post
    dos (PathOPERA3dMAGNETIC_post, '-echo');

    % Remove the files Opra for a new iteration
    delete transfor_magnetic.op3
    delete transfor_magnetic.res
    delete transfor_magnetic.opc


    % Launch automatically the file command THERMIQUE_pre.comi
    PathOPERA3dTHERMIQUE_pre=[PathOPERA3dMODELLER_TH ' transfor_thermal_pre.comi'];

    % Get a move on OPERA 3D THERMIQUE_pre
    dos (PathOPERA3dTHERMIQUE_pre, '-echo');

    % Launch automatically the file command THERMIQUE_post.comi 
    PathOPERA3dTHERMIQUE_post=[PathOPERA3dPOST_TH ' transfor_thermal_post.comi'];

    % Get a move on OPERA 3D THERIMIQUE_post
    dos (PathOPERA3dTHERMIQUE_post, '-echo');

    % Remove the files Opra for a new iteration
    delete transfor_thermal.op3
    delete transfor_thermal.res
    delete transfor_thermal.opc

    fid(i)=fopen('temporaire_thermique.txt','r');
    T_update = textscan(fid(i), '%f %f')
    Tcu = T_update{1};
    fclose(fid);
    if (i>10)
        break 
    end
    fprintf('\n!!!Pas encore trouv la convergence!!! Continuer la boucle \n')
    toc;
    t=t+toc;
end

fprintf('\n!!!Arrter!!! Trouver la convergence MAGNETIQUE-THERMIQUE \n')
fprintf('Temps total de la boucle Magnetic-Thermal t=%3.2f minutes \n\n',t/60)

%-------------------------------------------------------------------------%
%                   Launch the simulation in no-load                      %
%             to determine another responses of fine model                %
%-------------------------------------------------------------------------%

% Give the link for Opra 3D MODELLER and POST-PROCESSOR
global PathOPERA3dMODELLER_MA_vide; PathOPERA3dMODELLER_MA_vide=[vfdir '/bin/modeller.exe'];
global PathOPERA3dPOST_MA_vide; PathOPERA3dPOST_MA_vide=[vfdir '/bin/post.exe'];

% Launch automatically the command file MAGNETIC_pre.comi
PathOPERA3dMAGNETIC_vide_pre=[PathOPERA3dMODELLER_MA_vide ' transfor_magnetic_vide_pre.comi'];

% Get a move on OPERA 3D MAGNETIC_pre
dos (PathOPERA3dMAGNETIC_vide_pre, '-echo');

% Launch automatically the command file MAGNETIC_post.comi
PathOPERA3dMAGNETIC_vide_post=[PathOPERA3dPOST_MA_vide ' transfor_magnetic_vide_post.comi'];

% Get a move on OPERA 3D MAGNETIC_post
dos (PathOPERA3dMAGNETIC_vide_post, '-echo');


delete transfor_magnetic_vide.op3
delete transfor_magnetic_vide.res
delete transfor_magnetic_vide.opc

