% Matrix Jacopian of implicit system of 8 quations
%%%   TRAN Tuan Vu - 27/11/2006  %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% Implicite system of 8 quations


% r2-rhocuivre*(1+alphacuivre*Tcuivre)*n2*l2spire/S2fil = 0;
% X2-1/3*muo*n2^2*c*(4*a+2*d+pi*c)/b = 0;
% n2-n1*(V2+DV2)/V1 = 0;
% DV2-(R2*fp2+X2*sin(acos(fp2)))*I2=0;
% Pj-R2*I2^2 = 0;
% Tcuivre-Text-Rcuivreair*(Rferair*Pfer+(Rferair+Rfercuivre)*Pj)/(Rcuivreair+Rferair+Rfercuivre)=0;
% r1-rhocuivre*(1+alphacuivre*Tcuivre)*n1*l1spire/S1fil = 0;
% R2-r2-(n2/n1)^2*r1 = 0;

function [F,J] = sys_equa_silmu(x)

global c b kr rhocuivre alphacuivre l2spire muo a d n1 V2 V1 fp2 I2 
global Text Rcuivreair Rferair Rfercuivre l1spire Pfer f S1fil S2fil

r2=x(1);
X2=x(2);
n2=x(3);
DV2=x(4);
Pj=x(5);
Tcuivre=x(6);
r1=x(7);
R2=x(8);
   

% Implicit system of 8 equations

    F(1)=r2-rhocuivre*(1+alphacuivre*Tcuivre)*n2*l2spire/S2fil;
    F(2)=X2-1/3*muo*n2^2*c*(4*a+2*d+pi*c)/b*2*pi*f;
    F(3)=n2-n1*(V2+DV2)/V1;
    F(4)=DV2-(R2*fp2+X2*sin(acos(fp2)))*I2;
    F(5)=Pj-R2*I2^2;
    F(6)=Tcuivre-Text-Rcuivreair*(Rferair*Pfer+(Rferair+Rfercuivre)*Pj)/(Rcuivreair+Rferair+Rfercuivre);
    F(7)=r1-rhocuivre*(1+alphacuivre*Tcuivre)*n1*l1spire/S1fil;
    F(8)=R2-r2-(n2/n1)^2*r1;    
    
if nargout>1

    
    J = [1, 0, -rhocuivre*(1+alphacuivre*Tcuivre)*l2spire/S2fil, 0, 0, -rhocuivre*alphacuivre*n2*l2spire/S2fil, 0, 0;
        0, 1, -4/3*muo*n2*c*(4*a+2*d+pi*c)*pi*f/b, 0, 0, 0, 0, 0;
        0, 0, 1, -n1/V1, 0, 0, 0, 0;
        0, -sin(acos(fp2))*I2, 0, 1, 0, 0, 0, -fp2*I2;
        0, 0, 0, 0, 1, 0, 0, -I2^2;
        0, 0, 0, 0, -Rcuivreair*(Rferair+Rfercuivre)/(Rcuivreair+Rferair+Rfercuivre), 1, 0, 0;
        0, 0, 0, 0, 0, -rhocuivre*alphacuivre*n1*l1spire/S1fil, 1, 0;
        -1, 0, -2*n2/n1^2*r1, 0, 0, 0, -n2^2/n1^2, 1];    
   
    
end   
        

    
    
    